#!/bin/sh
set -x
# Version: 0.0.5 pre-alpha
# Author: Dimitrios Dimitrakos mail@dimitrios.de
# $Id: vdrconvert.sh,v 1.2 2003/06/28 14:33:34 dimi Exp $

. ./vdrconvert.env

# For the environment
. ./vdrconvert.env
# Default values for executables
[ -z "$VDRROOT" ]    && export VDRROOT=/video
[ -z "$DESTDIR" ]    && export DESTDIR=/video
[ -z "$VDRSYNC" ]    && export VDRSYNC=vdrsync.pl
[ -z "$TCMPLEX" ]    && export TCMPLEX=tcmplex
[ -z "$MKISOFS" ]    && export MKISOFS=mkisofs
[ -z "$MENCODER" ]   && export MENCODER=mencoder
[ -z "$TRANSCODE" ]  && export TRANSCODE=transcode
[ -z "$LAME" ]       && export LAME=lame
[ -z "$DVDAUTHOR" ]  && export DVDAUTHOR=dvdauthor
[ -z "$TOSVCD" ]     && export TOSVCD=tosvcd
# Nice level
[ -z "$PRIO" ]       && export PRIO=10
[ -z "$SLEEP_TIME" ] && export SLEEP_TIME=5
# Default Directorys
[ -z "$TEMPDIR" ]    && export TEMPDIR=$DESTDIR/tmp
# VDR Messages
[ -z "$SVDRPSEND" ]  && export SVDRPSEND=svdrpsend.pl
# Schalter

while true; do	
  for JOBFIL in $CONVERT_JOBS
  do
    if ! test -f $JOBFIL; 
      then echo $JOBFIL not found ! Creating empty one !!!
      touch $JOBFIL;
    fi

    if ! test -f $JOBFIL".done"; 
      then echo $JOBFIL".done" not found ! Creating empty one !!!
      touch $JOBFIL".done";
    fi

      LINES=`cat $JOBFIL | wc -l`  #Lines ermitteln (gibt Anzahl )

      if ! test $LINES = 0;
        then
    	  echo "This one is waiting for Jobs in $JOBFIL to process ....."
    	  echo
          NewJobs=`mktemp ./Job.XXXXXX`
          mv $JOBFIL $NewJobs
          touch $JOBFIL
	  echo "Start ${JOBFIL}.sh $NewJobs $JOBFIL >/tmp/${JOBFIL}.log"
	  ./${JOBFIL}.sh $NewJobs $JOBFIL >>/tmp/${JOBFIL}.log 2>&1 &
      fi
  done
  sleep $SLEEP_TIME
done

