#!/bin/sh
set -x
# Version: 0.0.5 pre-alpha
# Author: Dimitrios Dimitrakos mail@dimitrios.de
# $Id: vdr2divx.sh,v 1.4 2003/06/28 14:33:03 dimi Exp $

. ./vdrconvert.env

# Default werte setzen
# Verzeichnisse / Dateinamen
[ -z "$DIVX_DESTDIR" ] 	 && DIVX_DESTDIR=$DESTDIR/divx
[ -z "$DIVXTYPE" ] 	 && DIVXTYPE=lavc
[ -z "$DIVX_SUFFIX" ] 	 && DIVX_SUFFIX=avi
# Optionen
[ -z "$DIVXCCHOPT" ] 	 && DIVXCCHOPT="-cache 32768" 
[ -z "$DIVXENCOPT" ] 	 && DIVXENCOPT="" # Sonstige optionen
[ -z "$DIVXTCMODE" ] 	 && DIVXTCMODE=s
[ -z "$DIVXVLAVCCODEC" ] && DIVXVLAVCCODEC=mpeg4
[ -z "$DIVXQUALITY" ] 	 && DIVXQUALITY=5
[ -z "$DIVXMP3R" ] 	 && DIVXMP3R=192
[ -z "$DIVXMP3_OPTS" ] 	 && DIVXMP3_OPTS="-b $DIVXMP3R -h"
[ -z "$DIVXSWS" ] 	 && DIVXSWS=2
[ -z "$DIVXCDLEN" ] 	 && DIVXCDLEN=750
[ -z "$DIVXMAXBITR" ] 	 && DIVXMAXBITR=2480 
[ -z "$DIVXMINBITR" ] 	 && DIVXMINBITR=0
# Schalter
[ -z "$DIVXHQ" ] 	 && DIVXHQ="yes"
[ -z "$DIVXNOAC3" ]	 && DIVXNOAC3=no
[ -z "$DIVXAC3ONLY" ]	 && DIVXAC3ONLY=no
[ -z "$DIVXBOTHMP" ]	 && DIVXBOTHMP=no
[ -z "$DIVXFAKTOR" ]	 && DIVXFAKTOR=3
[ -z "$DIVXAUTOCROP" ]	 && DIVXAUTOCROP=no

# Check ob alle Programme ausfhrbar sind
# TODO

NewJobs=$1
JOBFIL=$2
DESTDIR=$DIVX_DESTDIR
TEMPDIR=${TEMPDIR}/${JOBFIL}

[ -d $DESTDIR ] || mkdir -p $DESTDIR 
[ -d $TEMPDIR ] || mkdir -p $TEMPDIR

if [ -w ${TEMPDIR} -a -w ${DESTDIR} ]
then
      declare CMDLIN=`head -n1 $NewJobs`   # Job auslesen
      rm $NewJobs
      let Number=1
      for i in $CMDLIN
      do
	  UniqueDir[Number]=`mktemp -d ${TEMPDIR}/VDRSYNC.XXXXXX`
	  status=$?
	  if [ $status -eq 0 ]
	  then
	      mkdir -p ${UniqueDir[Number]} 

	      spalten=`echo $i|sed 's/\// /g'|wc -w`
	      Record=`echo $i|sed 's/\%//g'|cut -f $spalten -d '/'`
	      let spalten=spalten-1
	      SubTitel=`echo $i|cut -f $spalten -d '/'`
	      Datum=`basename $i|cut -f1 -d'.'`
	      if [ "/$SubTitel" = "$VDRROOT" ] 
	      then
		  Titel=${Datum}_${Record} 
	      else
		  Titel=${SubTitel}/${Datum}_${Record}
		  [ ! -d ${UniqueDir[Number]}/${SubTitel} ] && mkdir -p ${UniqueDir[Number]}/${SubTitel}
		  [ ! -d ${DESTDIR}/${SubTitel} ] && mkdir -p ${DESTDIR}/${SubTitel}
	      fi
	      cd ${UniqueDir[Number]} # Temporaere Dateien sollen hier erstellt werden
	      LOG=${UniqueDir[Number]}/sync.log
	      if [ "$DIVXNOAC3" = "yes" ] 
	      then
		  if [ "$DIVXBOTHMP" = "yes" ]
		  then
		      echo -o ${UniqueDir[Number]} $i/ |xargs nice -$PRIO $VDRSYNC | tee $LOG 
		  else
		      echo -o ${UniqueDir[Number]} $i/ |xargs nice -$PRIO $VDRSYNC | tee $LOG 
		  fi
	      else
		  echo -o ${UniqueDir[Number]} $i/ |xargs nice -$PRIO $VDRSYNC | tee $LOG
	      fi

	      if [ "$DIVXAC3ONLY" = "yes" -a -f ${UniqueDir[Number]}/bd.ac3 ]
	      then 
		      echo "TCMplex mit Primaerton AC3"
	              nice -${PRIO} $TCMPLEX -i ${UniqueDir[Number]}/*.mpv -p ${UniqueDir[Number]}/bd.ac3 -m $DIVXTCMODE -o ${UniqueDir[Number]}/${Titel}.mpg 
	              AC3OPT="-aid 128 -oac copy"
	              let ABITR=448
	      else 
	              AC3OPT="-oac copy"
		      if [ "$DIVXBOTHMP" = "yes" ]
		      then
			  echo "Schalter fr beide MPG spuren gefunden"
			  if [ -f ${UniqueDir[Number]}/c0.mpa -a -f ${UniqueDir[Number]}/c1.mpa ]
			  then
			      echo "Beide MPEG spuren zu MP3"
	      		      echo "--mp2input $DIVXMP3_OPTS ${UniqueDir[Number]}/c0.mpa ${UniqueDir[Number]}/c0.mp3"|xargs nice -${PRIO} $LAME
	      		      echo "--mp2input $DIVXMP3_OPTS ${UniqueDir[Number]}/c1.mpa ${UniqueDir[Number]}/c1.mp3"|xargs nice -${PRIO} $LAME
	                      ABITR=$(($DIVXMP3R+$DIVXMP3R))
	                      nice -${PRIO} $TCMPLEX -i ${UniqueDir[Number]}/*.mpv -p ${UniqueDir[Number]}/c0.mp3 -s ${UniqueDir[Number]}/c1.mp3 -m $DIVXTCMODE -o ${UniqueDir[Number]}/${Titel}.mpg 
			  else
			      if [ -f ${UniqueDir[Number]}/c0.mpa ]
			      then
				  echo "Erste MPEG spur zu MP3. Zweite existiert nicht"
	      		          echo "--mp2input $DIVXMP3_OPTS ${UniqueDir[Number]}/c0.mpa ${UniqueDir[Number]}/c0.mp3"|xargs nice -${PRIO} $LAME
	                          nice -${PRIO} $TCMPLEX -i ${UniqueDir[Number]}/*.mpv -p ${UniqueDir[Number]}/c0.mp3 -m $DIVXTCMODE -o ${UniqueDir[Number]}/${Titel}.mpg 
	                          ABITR=$DIVXMP3R
			      fi
			  fi
		      else
			  if [ -f ${UniqueDir[Number]}/c0.mpa -a -f ${UniqueDir[Number]}/bd.ac3 ]
			  then
			      echo "primaer MPEG3 und sekundr AC3 verarbeitung"
	      		      echo "--mp2input $DIVXMP3_OPTS ${UniqueDir[Number]}/c0.mpa ${UniqueDir[Number]}/c0.mp3"|xargs nice -${PRIO} $LAME
	                      nice -${PRIO} $TCMPLEX -i ${UniqueDir[Number]}/*.mpv -p ${UniqueDir[Number]}/c0.mp3 -s ${UniqueDir[Number]}/bd.ac3 -m $DIVXTCMODE -o ${UniqueDir[Number]}/${Titel}.mpg 
	                      ABITR=$(($DIVXMP3R+448))
			  else
			      if [ -f ${UniqueDir[Number]}/c0.mpa ]
			      then
			          echo "primaer MPEG3 verarbeitung"
	      		          echo "--mp2input $DIVXMP3_OPTS ${UniqueDir[Number]}/c0.mpa ${UniqueDir[Number]}/c0.mp3"|xargs nice -${PRIO} $LAME
	                          nice -${PRIO} $TCMPLEX -i ${UniqueDir[Number]}/*.mpv -p ${UniqueDir[Number]}/c0.mp3 -m $DIVXTCMODE -o ${UniqueDir[Number]}/${Titel}.mpg 
	                          ABITR=$DIVXMP3R
			      fi
			  fi
		      fi
	      fi
    
	      # Bitrate berechnen
	      # Erst Laenge in MB ( nur Info )
              lmovie=`cat $LOG|grep "Mbytes read"|tail -1|awk '{print $1}'`
	      # Jetzt Laenge aus sec -> Minuten
              sec=`cat $LOG|grep "sec"|tail -1|cut -f2 -d '('|cut -f1 -d')'|awk '{print $1}'|cut -f1 -d'.'`
              min=$((sec/60))
              echo "File ${Titel} hat eine Lnge von $min Minuten bei $lmovie MB"
	      # Audio Bitraten finden
	      # Bitrate kann berechnet werden
	      [ $DIVXCDLEN -gt $((lmovie/DIVXFAKTOR)) ] && LEN=$((lmovie/DIVXFAKTOR)) || LEN=$DIVXCDLEN
	      [ $LEN -le 0 ] && LEN=1
	      VBITRT=$(((((LEN*1024*8/1000)*1024)-(ABITR*min*60))/(min*60)))
	      [ $DIVXMINBITR -gt 0 -a $VBITRT -le $DIVXMINBITR ] && VBITRT=$DIVXMINBITR 
	      echo "Berechnete Bitrate fr eine Lnge $LEN = $VBITRT"

	      ASPECT=`$MENCODER -frames 0 ${UniqueDir[Number]}/${Titel}.mpg 2>/dev/null|grep aspect|cut -f1 -d ')'|awk '{print $5}'`
	      if [ "$ASPECT" = "3" ] 
	      then
    	          X=`$MENCODER -frames 0 ${UniqueDir[Number]}/${Titel}.mpg 2>/dev/null|grep aspect|cut -f1 -d ')'|awk '{print $3}'|cut -f1 -d'x'`
    	          Y=$(($X*9/16))
    	          ASPOPT="-vop scale=$X:$Y -sws $DIVXSWS"
	          DIVXCROP=""
		  let step=0
		  let crop_ok=0
                  if [ "$DIVXAUTOCROP" = "yes" ]
	          then
		      for i in 00:05:00 00:10:00 00:15:00 00:20:00 00:25:00 00:30:00 00:35:00 00:40:00 00:45:00 01:00:00 01:15:00 01:30:00
		      do
		        DIVXCROP[step]=""
                        nice -${PRIO} $MENCODER -ss $i -frames 100 $DIVXENCOPT $AC3OPT $DIVXCCHOPT $ASPOPT \
		          -vop cropdetect \
                          -mc 0 \
                          -vc mpeg12 \
                          -ovc lavc \
                          -lavcopts vcodec=$DIVXVLAVCCODEC:vhq:ildct:vqmin=2:vbitrate=$VBITRT \
                          -o /dev/null \
                          ${UniqueDir[Number]}/${Titel}.mpg > ${UniqueDir[Number]}/crop.log
			status=$?
			if [ $status -eq 0 ]
			then
		          DIVXCROP[step]=`cat ${UniqueDir[Number]}/crop.log|grep crop= |tail -1 | cut -f3 -d '('|sed 's/)//'|sed 's/-vop //'`
			  [ ! -z "${DIVXCROP[step]}" ] && let step=step+1
			fi
		      done
		      if [ $step -ge 2 ]
		      then
	                  until [ $step -eq 1 -o $crop_ok -eq 3 ] 
		          do
		      	      let crop_ok=0
		      	      let ustep=step
	                      until [ $ustep -eq 1 -o $crop_ok -eq 3 ] 
		              do
			  	if [ ! -z "${DIVXCROP[ustep]}" -a "${DIVXCROP[ustep]}" = "${DIVXCROP[ustep-1]}" ] 
				then
				   let crop_ok=crop_ok+1
				fi
				let ustep=ustep-1
		              done
			      let step=step-1
		          done
		      fi
		      if [ $crop_ok -eq 3 ]
		      then
		          CROPMIN=`echo ${DIVXCROP[step]}|cut -f 4 -d ':'`
			  echo "CROP : $crop_ok Treffer gefunden."
		          Y=$(($Y-$CROPMIN))
    	                  ASPOPT="-vop scale=$X:$Y,$DIVXCROP -sws $DIVXSWS"
		      fi
	          fi
	      else
	          ASPOPT=""
	      fi
   	 
              if [ "$DIVXHQ" = "yes" ]
	      then
		  case $DIVXTYPE in
		      lavc)
		          echo "Erstelle $DIVXTYPE Format 2 Pass"
	                  for pass in 1 2 
	                  do
    	 	            nice -${PRIO} $MENCODER $DIVXENCOPT $AC3OPT $DIVXCCHOPT $ASPOPT \
		 	      -mc 0 \
		 	      -vc mpeg12 \
		 	      -passlogfile ${UniqueDir[Number]}/divx2pass.log \
		 	      -ovc lavc \
		 	      -lavcopts vcodec=$DIVXVLAVCCODEC:vhq:ildct:vpass=$pass:vqmin=2:vbitrate=$VBITRT \
		 	      -o ${UniqueDir[Number]}/output.avi \
		 	      ${UniqueDir[Number]}/${Titel}.mpg 
    
	   		    status=$?
		          done
		          ;;
		      divx)
		          echo "Erstelle  $DIVXTYPE Format 2 Pass"
	                  for pass in 1 2 
	                  do
                            nice -${PRIO} $MENCODER $DIVXENCOPT $AC3OPT $DIVXCCHOPT $ASPOPT \
                              -mc 0 \
                              -vc mpeg12 \
                              -passlogfile ${UniqueDir[Number]}/divx2pass.log \
                              -ovc divx4 \
                              -divx4opts pass=$pass:q=$DIVXQUALITY:br=$VBITRT \
                              -o ${UniqueDir[Number]}/output.avi \
                              ${UniqueDir[Number]}/${Titel}.mpg
    
	   		    status=$?
		          done
                           ;;
		      xvid)
		          echo "Erstelle  $DIVXTYPE Format sincle Pass"
                          nice -${PRIO} $MENCODER $DIVXENCOPT $AC3OPT $DIVXCCHOPT $ASPOPT \
                              -mc 0 \
                              -vc mpeg12 \
                              -ovc xvid \
                              -xvidopts dr2 \
                              -o ${UniqueDir[Number]}/output.avi \
                              ${UniqueDir[Number]}/${Titel}.mpg
    
	   	          status=$?
                          ;;
    		      *)
        	           echo "Encodertype $DIVXTYPE wird nicht untersttzt."
		           status=2001
        	        ;;
		  esac
	     else
	         DIVXTYPE=DivXLQ
		 VBITRT=400
	         X=$((X/2))
	         Y=$((Y/2))
    	         ASPOPT="-vop scale=$X:$Y -sws $DIVXSWS"
                 echo "Erstelle DivX LQ Format (q=1, bitr=400) sincle Pass"
	         nice -${PRIO} $MENCODER $DIVXENCOPT $AC3OPT $DIVXCCHOPT $ASPOPT \
                     -mc 0 \
                     -vc mpeg12 \
                     -o ${UniqueDir[Number]}/output.avi \
                     -ovc divx4 \
                     -divx4opts q=1:br=400 \
                     ${UniqueDir[Number]}/${Titel}.mpg 

	         status=$?
	     fi
	      
	     if [ $status -eq 0 ]
	     then
		if [ ! -f ${DESTDIR}/${Titel}\(${DIVXTYPE}_${VBITRT}\).${DIVX_SUFFIX} ]
		then
		     cp ${UniqueDir[Number]}/output.avi ${DESTDIR}/${Titel}\(${DIVXTYPE}_${VBITRT}\).${DIVX_SUFFIX}
		     status=$?
		else
		    let index=1
		    until [ ! -f ${DESTDIR}/${Titel}\(${DIVXTYPE}_${VBITRT}\)-$index.${DIVX_SUFFIX} ]
		    do
			let index=index+1
		    done
		    cp ${UniqueDir[Number]}/output.avi ${DESTDIR}/${Titel}\(${DIVXTYPE}_${VBITRT}\)-$index.${DIVX_SUFFIX}
		fi
	     fi
    	  fi

	  if [ ! $status -eq 0 ]
	  then
	      echo "Bei der Konvertierung von ${DESTDIR}/${Titel}\(${DIVXTYPE}_${VBITRT}\).${DIVX_SUFFIX} ist es zu Fehlern gekommen.status=<${status}>"
	  else
	  # Medium Brennen
	  echo "Brennvorgang"
	  fi

	  # Temp Files lschen
	  cd -
          rm -rf ${UniqueDir[Number]}
          echo $CMDLIN >> ${JOBFIL}.done
	  let Number=Number+1
      done
else
    echo "Bitte die Schreibechte fr ${TEMPDIR} und ${DESTDIR} berprfen. Keine verarbeitung mglich"
fi

